void delay(dword ticks) 
	{
	while(ticks--)
		;
	}

#define LCD_E  (1 << 5) // portd
#define LCD_RS (1 << 6) // portc
#define LCD_RW (1 << 5) // portc

#define lcd_set_e()  (PORTD |= LCD_E)
#define lcd_set_rs() (PORTC |= LCD_RS)
#define lcd_set_rw() (PORTC |= LCD_RW)

#define lcd_clear_e()  (PORTD &= ~LCD_E)
#define lcd_clear_rs() (PORTC &= ~LCD_RS)
#define lcd_clear_rw() (PORTC &= ~LCD_RW)

void lcd_pulse(void) // strobe
	{
	lcd_set_e();
	delay(15);
	lcd_clear_e();
	delay(15);
	}

void lcd_wait(void) // long delay
	{
	delay(2500);
	}

void lcd_send(byte data)
	{
	PORTA = data;  
	lcd_pulse();
	}

void clrscr(void) // clear display
	{      
	delay(5);
	lcd_clear_rs();
	delay(5);
	lcd_clear_rw();
	delay(5);
	lcd_send(0x01);
	lcd_wait();
	}

void initgraph(void) // initialize
	{
	DDRD |= LCD_E;
	DDRA = 0xFF;
	lcd_clear_rs();
	lcd_clear_rw();
	lcd_wait(); 
	lcd_send(0x3C); 
	lcd_wait(); 
	lcd_send(0x3C);
	lcd_wait(); 
	lcd_send(0x3C);
	lcd_wait(); 
	lcd_send(0x06);
	lcd_wait(); 
	lcd_send(0x0C);
	lcd_wait(); 
	lcd_send(0x01);
	lcd_wait(); 
	}    

void gotoz(byte z) // goto absolute address
	{
	lcd_clear_rs();
	lcd_clear_rw();
	lcd_send(z | 0x80);
	}

#define gotoxy(x,y) gotoz(x|(y<<6))

void putchar(char c) // write char to display
	{
	lcd_clear_rw();
	lcd_set_rs();
	lcd_send(c);
	}

void outtext(char* text) // output '\0'-padded string
	{
	while(*text)
		putchar(*text++);
	}
