; dac example
; 128 kHz sampling
; dac AD5302 channel A output
; output = sine, table of 256 cells
; 25/03/2004

.include "m128def.inc"

reset:
	ldi	r16,low(ramend)
	out	spl,r16
	ldi	r16,high(ramend)
	out	sph,r16

	ser	r16
	out	PORTB,r16
	ldi	r16,$c6
	out	DDRB,r16

	ldi	r16,$58
	out	SPCR,r16
	ldi	r16,$01
	out	SPSR,r16

	cbi	PORTB,6 ; ldac = 0

	clr	zl

	ldi	zl,low(table*2)
	ldi	zh,high(table*2)

loop:
	lpm	; read next sine byte from table

	cbi	portb,7	; sync = 0

	mov	r16,r0	; prepare high byte
	lsr	r16	
	lsr	r16	
	lsr	r16	
	lsr	r16	

	out	SPDR,r16 ; write
waitspi1:
	sbis	SPSR,SPIF
	rjmp	waitspi1

	mov	r16,r0	; prepare low byte
	lsl	r16	
	lsl	r16	
	lsl	r16	
	lsl	r16	


	out	SPDR,r16 ; write
waitspi2:
	sbis	SPSR,SPIF
	rjmp	waitspi2

	sbi	portb,7	; sync = 1

	inc	zl	; go to next byte w/ overlap

	rjmp	loop

; sine table

.org	$80

table:
	.db     $80,$83,$86,$89,$8c,$8f,$92,$96,$99,$9c,$9f,$a2,$a5,$a8,$aa,$ad
	.db     $b0,$b3,$b6,$b9,$bb,$be,$c1,$c3,$c6,$c9,$cb,$ce,$d0,$d2,$d5,$d7
	.db     $d9,$db,$dd,$df,$e1,$e3,$e5,$e7,$e9,$ea,$ec,$ee,$ef,$f1,$f2,$f3
	.db     $f4,$f6,$f7,$f8,$f9,$f9,$fa,$fb,$fc,$fc,$fd,$fd,$fd,$fe,$fe,$fe
	.db     $fe,$fe,$fe,$fe,$fd,$fd,$fd,$fc,$fc,$fb,$fa,$f9,$f9,$f8,$f7,$f6
	.db     $f4,$f3,$f2,$f1,$ef,$ee,$ec,$ea,$e9,$e7,$e5,$e3,$e1,$df,$dd,$db
	.db     $d9,$d7,$d5,$d2,$d0,$ce,$cb,$c9,$c6,$c3,$c1,$be,$bb,$b9,$b6,$b3
	.db     $b0,$ad,$aa,$a8,$a5,$a2,$9f,$9c,$99,$96,$92,$8f,$8c,$89,$86,$83
	.db     $80,$7d,$7a,$77,$74,$71,$6e,$6a,$67,$64,$61,$5e,$5b,$58,$56,$53
	.db     $50,$4d,$4a,$47,$45,$42,$3f,$3d,$3a,$37,$35,$32,$30,$2e,$2b,$29
	.db     $27,$25,$23,$21,$1f,$1d,$1b,$19,$17,$16,$14,$12,$11,$0f,$0e,$0d
	.db     $0c,$0a,$09,$08,$07,$07,$06,$05,$04,$04,$03,$03,$03,$02,$02,$02
	.db     $02,$02,$02,$02,$03,$03,$03,$04,$04,$05,$06,$07,$07,$08,$09,$0a
	.db     $0c,$0d,$0e,$0f,$11,$12,$14,$16,$17,$19,$1b,$1d,$1f,$21,$23,$25
	.db     $27,$29,$2b,$2e,$30,$32,$35,$37,$3a,$3d,$3f,$42,$45,$47,$4a,$4d
	.db     $50,$53,$56,$58,$5b,$5e,$61,$64,$67,$6a,$6e,$71,$74,$77,$7a,$7d

; done