//   -   AS-megaM   /     RS232
//    

#include "asmegam.h"
#include "lcd.h"

void port_init(void) //    , LED0 = 1, LED1 = 0
{
	DDRD |= (LED0 | LED1);
	PORTD |= (LED0 | LED1);
}

void timer0_init(void) //   :      
{
	TCCR0 = 0x00; //     
	ASSR  = 0x08; //      
	TCNT0 = 0x00; // 
	TCCR0 = 0x04; // 
}

byte time[4] = { 0,0,0,0 }; //     
// time[0] -      (0/1)
// time[1] -  (0..59)
// time[2] -  (0..59)
// time[3] -  (0..23)

void byte2chr(byte v, char* a, char* b) //    (0..99)   
{
	(*a) = (*b) = 0;
	(*b) = v;
	while(*b >= 10) //   10
	{
		(*b) -= 10;
		(*a)++;
	}
	(*a) += '0';
	(*b) += '0'; 
}

char c[6]; //      

void output_time(void) //    
{
	byte2chr(time[3],&c[0],&c[1]);
	byte2chr(time[2],&c[2],&c[3]);
	byte2chr(time[1],&c[4],&c[5]);
	gotoxy(0,0);
	putchar(c[0]);
	putchar(c[1]);
	putchar(' ');
	putchar(c[2]);
	putchar(c[3]);
	putchar(' ');
	putchar(c[4]);
	putchar(c[5]);
}

void timer(void) //  
{       
    PORTD ^= (LED0 | LED1); //     ("")
	
	time[0] ^= 1; // 1-time[0]
	if(!time[0]) //     
	{
		time[1]++;
		if(time[1] == 60)
		{
			time[1] = 0;
			time[2]++;
			if(time[2] == 60)
			{
				time[2] = 0;
				time[3]++;
				if(time[3] == 24)
					time[3] = 0;
			}
		}
	}
	
	output_time(); // 
}         

// 

byte timer0_function = 0;
word tc1_value;

#pragma interrupt_handler timer0_ovf_isr:17
void timer0_ovf_isr(void)
{
	if(timer0_function == 1)
		timer();
	else if(timer0_function == 2) //        
	{
		tc1_value = TCNT1;
		timer0_function = 0;
	}
}

void uart0_init(void) //  uart
{
	DDRE = (DDRE | 2) & ~1; //   - PE0 in, PE1 out
	
	UCSR0B = 0x00; //   uart
	UCSR0A = 0x00;
	UCSR0C = 0x06;
	UBRR0L = 0x17; //  19200
	UBRR0H = 0x00;
	UCSR0B = 0x18; // 
}


void uartsend(byte c) //  
{
	while(!(UCSR0A & BIT(UDRE0)))
		;
	UDR0 = c;
}

byte uartrecv() //  
{
	while(!(UCSR0A & BIT(RXC0)))
		;
	return UDR0;
}

void main(void) //  
{
	byte c;
	long v;
	char c1,c2,c3,c4;
	byte b;
	
	CLI(); //   
	XDIV  = 0x00; //  . ICCAVR AppBuilder
	XMCRA = 0x0A; //external memory
	XMCRB = 0x00;
	port_init();
	uart0_init();
	MCUCR = 0x00;
	EICRA = 0x00;
	EICRB = 0x00;
	EIMSK = 0x00;
	TIMSK = 0x01;
	ETIMSK = 0x00;
	
	init_lcd(); //    

	//   
	outtext("Measuring...");
	
	TCCR1A = 0;
	TCCR1B = 4;
	TCCR1C = 0;
	TCNT1 = 0;
	
	// "" 
	timer0_function = 2;
	timer0_init();
	SEI();
	while(timer0_function)
		;
	CLI();
	
	//  
	timer0_function = 2;
	timer0_init();
	TCNT1 = 0;
	SEI();
	while(timer0_function)
		;
	CLI();

	//   tc1_value - 
	//   t/c1     - 
	//   
	v = tc1_value-1;
	v *= 512;
	v += 5000;
	c1 = (v/10000000)%10;
	c2 = (v/1000000)%10;
	c3 = (v/100000)%10;
	c4 = (v/10000)%10;
	
	//     
	clrscr();
	
	outtext("f = ");
	
	if(c1)
		putchar(c1+'0');
	putchar(c2+'0');
	putchar(',');
	putchar(c3+'0');
	putchar(c4+'0');
	outtext(" MHz");
	
	// 
	timer0_function = 2;
	timer0_init();
	SEI();
	while(timer0_function)
		;
	CLI();
	
	timer0_function = 2;
	timer0_init();
	SEI();
	while(timer0_function)
		;
	CLI();
	
	timer0_function = 2;
	timer0_init();
	SEI();
	while(timer0_function)
		;
	CLI();
	
	//   - 
	clrscr();
	gotoxy(0,0);
	
	timer0_function = 1;
	timer0_init();
	
	PORTD |= LED0;
	PORTD &= ~LED1;
	
	SEI();
	
	while(1) //  
	{
		c = uartrecv(); //     
		
		if(c == '?') // 
		{
			uartsend(5);
			uartsend('c');
			uartsend('l');
			uartsend('k');
			uartsend('+');
			uartsend('f'); 
		}
		
		else if(c == 'g') //  
		{
			uartsend(time[1]);
			uartsend(time[2]);
			uartsend(time[3]);
		}
		
		else if(c == 's') //  
		{
			time[1] = uartrecv();
			time[2] = uartrecv();
			time[3] = uartrecv();
			uartsend(0x0d);
		}
	}
}
